/**
  * Additional (optional) stuff for ElysionNyx
  *
  *
  */
  
  
/**
  * Loading screen
  *
  *
  */
class elLoadScreen extends elObject
{
	private
		// Max steps of the loading bar
		int fMaxSteps;
	public
		elSprite backgroundSprite;
		elColor backgroundColor;
		elColor barColor;
		elColor barColorShadow;
		
		int step;
	
		/**
		  * Constructor for elLoadScreen
		  * Requires paramater for maximal steps
		  *
		  * @constructor
		  */
		elLoadScreen(int maxSteps)
		{
			super();
			
			fType = "elLoadScreen";
			refreshUniqueID();
			
			backgroundColor = new elColor(255, 255, 255);
			barColorShadow = new elColor(180, 180, 180);
			barColor = new elColor(64, 64, 64);
			
			backgroundSprite = new elSprite();
			
			step = 0;
			fMaxSteps = maxSteps;
		}
		
		/**
		  * Draw method of elLoadScreen
		  * 
		  * Draws background sprite if loaded and background bar color
		  */
		void draw()
		{
			background(backgroundColor.r, backgroundColor.g, backgroundColor.b);
			
			if (backgroundSprite.isLoaded())
			{
				backgroundSprite.position.x = ((width - backgroundSprite.width) / 2);
				backgroundSprite.position.y = ((height - backgroundSprite.height) / 2);
				
				backgroundSprite.draw();
			}
			
			stroke(barColorShadow.r, barColorShadow.g, barColorShadow.b, barColorShadow.a);
			fill(barColor.r, barColor.g, barColor.b, barColor.a);
			rect(20, height - 20, width - 40, 10);
		}
		
		/**
		  * Update method of elLoadScreen
		  *
		  * Updates loading bar
		  */
		void update()
		{
			stroke(barColorShadow.r, barColorShadow.g, barColorShadow.b, barColorShadow.a);
			fill(barColorShadow.r, barColorShadow.g, barColorShadow.b, barColorShadow.a);
			rect(20, height - 20, int((width - 40) * (step / fMaxSteps)), 10);
		}
}