String gameState;
boolean goLeft = false;
boolean goRight = false;
int score = 0;


class eIntroScreen extends elScene
{
	private
        elFont font;
        elFont title;

	public
    	eIntroScreen()
        {
        	super();

            fType = "eIntroScreen";
            refreshUniqueID();

            title = new elFont();
            title.fontColor = new elColor(0, 0, 0);
            title.fontSize = 20;
            title.loadFromFile("DejaVuSans.svg");



            font = new elFont();
            font.fontColor = new elColor(0, 0, 0);
            font.fontSize = 14;
            font.loadFromFile("DejaVuSans.svg");

        }

        void draw()
        {
        	background(255);

            title.textOut(new elVector2i(200, 10), "Road To Happiness");

            font.textOut(new elVector2i(10, 50), "In the Epicurean view, the highest pleasure [...] was ");
            font.textOut(new elVector2i(10, 70), "obtained by knowledge, friendship and living a virtuous and temperate life.");
            font.textOut(new elVector2i(10, 90), "He lauded the enjoyment of simple pleasures, by which he meant abstaining");
            font.textOut(new elVector2i(10, 110), "from bodily desires, such as sex and appetites, verging on asceticism.");
            font.textOut(new elVector2i(10, 170), "Source: http://en.wikipedia.org/wiki/Epicureanism");

            font.textOut(new elVector2i(10, 200), "Press A and S to move left or right and E to interact with objects.");
            font.textOut(new elVector2i(10, 300), "Click to continue");
        }

        void update()
        {
        	if (mousePressed) gameState = "level1";
        }
}

class eLevel1 extends elScene
{
	private
    	elSprite gHero;
        elSprite gObject1;
        elSprite gObject2;

        elFont font;

        int hposx;

    public
    	eLevel1()
        {
        	super();
            fType = "eLevel1";
            refreshUniqueID();

            hposx = 10;
            directionRight = true;
            gamelost = false;

            font = new elFont();
            font.fontColor = new elColor(0, 0, 0);
            font.fontSize = 14;
            font.loadFromFile("DejaVuSans.svg");

            gHero = new elSprite();
            gHero.loadFromFile("hero.png");
            gHero.position.y = height - 150;

            gObject1 = new elSprite();
            gObject1.loadFromFile("l1object1.png");
            gObject1.position.x = 100;
            gObject1.position.y = height - 220;

            gObject2 = new elSprite();
            gObject2.loadFromFile("l1object2.png");
            gObject2.position.x = 300;
            gObject2.position.y = height - 150;
        }

        void draw()
        {
        	background(235);

            GUI.box(new elRect(0, height - 30, width, height), new elColor(190, 190, 190));

            gObject1.draw();
            gObject2.draw();

            gHero.draw();


        }

        void update()
        {

            	if (keyPressed)
                {
                	if (key == 'a' || key == 'A')
                    {
                    	goLeft = true;
                        directionRight = false;
                    }
                    if (key == 's' || key == 'S')
                    {
                    	goRight = true;
                        directionRight = true;
                    }

                    if (key == 'e' || key == 'E')
                    {
                    	if ((hposx >= gObject1.position.x) && (hposx <= (gObject1.position.x + 133)))
                        {
                            score = score + 1;
                            gameState = "level2";
                        }

                        if ((hposx >= gObject2.position.x) && (hposx <= (gObject2.position.x + 198)))
                        {
                         	gameState = "level2";
                        }
                    }
                }
                else
                {
                	goLeft = false;
                    goRight = false;
                }



            	if (goLeft)
                {
                	if (hposx > 0) hposx = hposx - 3;

                }

                if (goRight)
                {
                	if (hposx < (width - 50)) hposx = hposx + 3;

                }

                gHero.position.x = hposx;


                if ((hposx >= gObject1.position.x) && (hposx <= (gObject1.position.x + 133)))
                	font.textOut(new elVector2i(50, 20), "Read books...");

                if ((hposx >= gObject2.position.x) && (hposx <= (gObject2.position.x + 198)))
                	font.textOut(new elVector2i(50, 20), "Browse the web...");


        }
}

class eLevel2 extends elScene
{
	private
    	elSprite gHero;
        elSprite gObject1;
        elSprite gObject2;

        elFont font;

        int hposx;

    public
    	eLevel2()
        {
        	super();
            fType = "eLevel2";
            refreshUniqueID();

            hposx = 10;
            directionRight = true;
            gamelost = false;

            font = new elFont();
            font.fontColor = new elColor(0, 0, 0);
            font.fontSize = 14;
            font.loadFromFile("DejaVuSans.svg");

            gHero = new elSprite();
            gHero.loadFromFile("hero.png");
            gHero.position.y = height - 150;

            gObject1 = new elSprite();
            gObject1.loadFromFile("l2object1.png");
            gObject1.position.x = 150;
            gObject1.position.y = height - 200;

            gObject2 = new elSprite();
            gObject2.loadFromFile("l2object2.png");
            gObject2.position.x = 350;
            gObject2.position.y = height - 200;
        }

        void draw()
        {
        	background(235);

            GUI.box(new elRect(0, height - 30, width, height), new elColor(190, 190, 190));

            gObject1.draw();
            gObject2.draw();

            gHero.draw();


        }

        void update()
        {

            	if (keyPressed)
                {
                	if (key == 'a' || key == 'A')
                    {
                    	goLeft = true;
                        directionRight = false;
                    }
                    if (key == 's' || key == 'S')
                    {
                    	goRight = true;
                        directionRight = true;
                    }

                    if (key == 'e' || key == 'E')
                    {
                    	if ((hposx >= gObject1.position.x) && (hposx <= (gObject1.position.x + 66)))
                        {
                            score = score + 1;
                            gameState = "level3";
                        }

                        if ((hposx >= gObject2.position.x) && (hposx <= (gObject2.position.x + 76)))
                        {
                         	gameState = "level3";
                        }
                    }
                }
                else
                {
                	goLeft = false;
                    goRight = false;
                }



            	if (goLeft)
                {
                	if (hposx > 0) hposx = hposx - 3;

                }

                if (goRight)
                {
                	if (hposx < (width - 50)) hposx = hposx + 3;

                }

                gHero.position.x = hposx;


                if ((hposx >= gObject1.position.x) && (hposx <= (gObject1.position.x + 66)))
                	font.textOut(new elVector2i(50, 20), "Make a new friend...");

                if ((hposx >= gObject2.position.x) && (hposx <= (gObject2.position.x + 76)))
                	font.textOut(new elVector2i(50, 20), "Spend a night with this lovely lady...");


        }
}

class eLevel3 extends elScene
{
	private
    	elSprite gHero;
        elSprite gObject1;
        elSprite gObject2;

        elFont font;

        int hposx;

    public
    	eLevel3()
        {
        	super();
            fType = "eLevel3";
            refreshUniqueID();

            hposx = 10;
            directionRight = true;
            gamelost = false;

            font = new elFont();
            font.fontColor = new elColor(0, 0, 0);
            font.fontSize = 14;
            font.loadFromFile("DejaVuSans.svg");

            gHero = new elSprite();
            gHero.loadFromFile("hero.png");
            gHero.position.y = height - 150;

            gObject1 = new elSprite();
            gObject1.loadFromFile("l3object1.png");
            gObject1.position.x = 50;
            gObject1.position.y = height - 260;

            gObject2 = new elSprite();
            gObject2.loadFromFile("l3object2.png");
            gObject2.position.x = 370;
            gObject2.position.y = height - 160;
        }

        void draw()
        {
        	background(235);

            GUI.box(new elRect(0, height - 30, width, height), new elColor(190, 190, 190));

            gObject1.draw();
            gObject2.draw();

            gHero.draw();


        }

        void update()
        {

            	if (keyPressed)
                {
                	if (key == 'a' || key == 'A')
                    {
                    	goLeft = true;
                        directionRight = false;
                    }
                    if (key == 's' || key == 'S')
                    {
                    	goRight = true;
                        directionRight = true;
                    }

                    if (key == 'e' || key == 'E')
                    {
                    	if ((hposx >= gObject1.position.x) && (hposx <= (gObject1.position.x + 295)))
                        {
                            score = score + 1;
                            gameState = "outroScreen";
                        }

                        if ((hposx >= gObject2.position.x) && (hposx <= (gObject2.position.x + 148)))
                        {
                         	gameState = "outroScreen";
                        }
                    }
                }
                else
                {
                	goLeft = false;
                    goRight = false;
                }



            	if (goLeft)
                {
                	if (hposx > 0) hposx = hposx - 3;

                }

                if (goRight)
                {
                	if (hposx < (width - 50)) hposx = hposx + 3;

                }

                gHero.position.x = hposx;


                if ((hposx >= gObject1.position.x) && (hposx <= (gObject1.position.x + 295)))
                	font.textOut(new elVector2i(50, 20), "Play piano...");

                if ((hposx >= gObject2.position.x) && (hposx <= (gObject2.position.x + 148)))
                	font.textOut(new elVector2i(50, 20), "Play video games...");


        }
}

class eOutroScreen extends elScene
{
	private
        elFont font;

    public
    	eOutroScreen()
        {
        	super();
            fType = "eOutroScreen";
            refreshUniqueID();

            font = new elFont();
            font.fontColor = new elColor(0, 0, 0);
            font.fontSize = 14;
            font.loadFromFile("DejaVuSans.svg");

        }

        void draw()
        {
        	background(235);

            if (score == 3) font.textOut(new elVector2i(10, 20), "You obtained 'the highest pleasure'.");
            else font.textOut(new elVector2i(10, 20), "Are you mocking Epicureanism?");

        }

        void update()
        {

        }
}
